import { MinecraftItemTypes,Items,ItemStack, BlockPermutation, MinecraftBlockTypes,EntityRaycastOptions, Location, Vector, BlockRaycastOptions, BlockLocation, world, EntityQueryOptions} from 'mojang-minecraft';
import * as Minecraft from 'mojang-minecraft';
import { Portalgun } from "scripts/Portalgun.js";
    
const tickCallback = Minecraft.world.events.tick;
const entityCallback = Minecraft.world.events.entityCreate;

tickCallback.subscribe(onTick);
entityCallback.subscribe(entityCreated);	

const forbiddenBlocks = ['barrier','bedrock'];
  
world.events.beforeChat.subscribe((eventData) => {
if(eventData.message != '!pg test') return;
eventData.sender.runCommand(`say ${eventData.sender.getComponent('inventory').container.getItem(eventData.sender.selectedSlot).id}`);
//eventData.sender.runCommand(`execute @s ~ ~ ~ loot spawn ~ ~ ~ loot "entities/chicken"`);
eventData.cancel = true;
});	
  
world.events.beforeItemUse.subscribe((eventData) => {
try{
let item = eventData.item;
let entity = eventData.source;
if(entity.id != 'minecraft:player') return;
let loc = entity.location;
let x = loc.x;
let y = loc.y;
let z = loc.z;
let dimension = entity.dimension;
let bRayCast = new BlockRaycastOptions();
let eQuery = new EntityQueryOptions();
eQuery.closest = 1;
eQuery.location = loc;
eQuery.families = ['block'];
eQuery.name = entity.name;
let entityBlocks = Array.from(dimension.getEntities(eQuery));
bRayCast.includeLiquidBlocks = false;
bRayCast.includePassableBlocks = true;
bRayCast.maxDistance = 5;
let block = entity.getBlockFromViewVector(bRayCast);
	//----Creator Feature-----
	hold_cube(eventData);
	//------------------------
	if(item.id == 'pg:portal_gun_levitation_beta' || item.id == 'pg:portal_gun_levitation2_beta'){
		let getCooldown = item.getComponent('minecraft:cooldown').cooldownTicks;
		//suppose to stop when in cooldown but it doesn't apparently
		if(getCooldown==20){
		if(entity.viewVector.y < -0.97) return;
		try{
		let eRayCast = new EntityRaycastOptions();
		eRayCast.maxDistance = 5;
		let entityShoot = entity.getEntitiesFromViewVector(eRayCast);
			if(((block && !entityBlocks.length) && !forbiddenBlocks.find(name=>block.id.includes(name))) && !entityShoot.length){
				let blockItem = blockToItem(block);
				let blockEntity = dimension.spawnEntity('pg:block',new Location(block.location.x,block.location.y,block.location.z));
				blockEntity.nameTag = entity.name;
					//Places converted block into main hand
					if(blockItem){
						try{
						let blockitemId = blockItem.id;
						if(blockItem.id.includes('minecraft:')){
							blockitemId = blockItem.id.split(':')[1];	
						//I hate you concrete powder and stone slabs
						if(blockitemId.includes('powder')) blockitemId = blockitemId.replace(/_/g,'');		
						if(blockitemId.includes('double_')) blockitemId = blockitemId.replace(/double_/g,'');	
						}
							//blockEntity.runCommand(`say ${blockitemId}`);		
							blockEntity.runCommand(`replaceitem entity @s slot.weapon.mainhand 0 ${blockitemId} 1 ${blockItem.data}`);
						}catch(e){}
					}
				let newTag = `block:${block.type.id}`
				for(let p of block.permutation.getAllProperties()){
					for(let p2 in p){
						newTag = newTag+`;${p2}:${p[p2]}`;
						//dimension.runCommand(`say ${p2} - ${p[p2]}`);	
					}
				}
				blockEntity.addTag(newTag);
				//dimension.runCommand(`setblock ${block.location.x} ${block.location.y} ${block.location.z} air 0 destroy`);
				block.setType(MinecraftBlockTypes.get('minecraft:air'));
			}else if(entityBlocks.length && entityBlocks[0].runCommand(`testforblock ~ ~ ~ air`)){				
				entityBlocks[0].addTag('shoot');
				if(entity.isSneaking) return;
				entityBlocks[0].setVelocity(new Vector(entity.viewVector.x*3,entity.viewVector.y*1.5,entity.viewVector.z*3));	
			}else if(entityShoot.length){
				if(entityShoot[0].id.split(':')[0] == 'pg') return;
				entityShoot[0].setVelocity(new Vector(entity.viewVector.x*3,entity.viewVector.y+0.3*2,entity.viewVector.z*3));
			}
		}catch(e){
		//world.getDimension(`overworld`).runCommand(`say ${e}`);		
		}
		
		}
	}else if((item.id == 'pg:portal_gun_blackhole_beta' || item.id == 'pg:portal_gun_blackhole2_beta') && entity.isSneaking){
		try{
		entity.runCommand(`event entity @e[name="${entity.name}'s BlackHole",family=blackhole] despawn`);
		}catch(e){}
	}
}catch(e){
//world.getDimension(`overworld`).runCommand(`say ${e}`);	
}
});  

function hold_cube(eventData){
let item = eventData.item;
let entity = eventData.source;
if(item.id.includes('blue') || item.id.includes('orange') || entity.hasTag('carrying_cube')){
	let entityRayCast = new EntityRaycastOptions();
	entityRayCast.maxDistance = 5;
	let getCube = entity.getEntitiesFromViewVector(entityRayCast)[0];
		if(getCube.id != 'pg:portal_cube') return;		
		getCube.addTag(entity.name);
		if(entity.hasTag('carrying_cube')){
		entity.removeTag('carrying_cube');	
		getCube.removeTag(entity.name);
		getCube.setVelocity(new Vector(entity.viewVector.x*2,entity.viewVector.y+0.3*1.5,entity.viewVector.z*2));
		eventData.cancel = true;
		return;
		}
		entity.addTag('carrying_cube');
		let ticks = world.events.tick.subscribe((eventData)=>{
		try{
		getCube.runCommand(`execute @p[name=${entity.name}] ~ ~ ~ tp @e[tag="${entity.name}",type=!player] ^ ^1 ^2 true`);
		}catch(e){}
			if(entity.isSneaking || !entity.hasTag('carrying_cube')){
			entity.removeTag('carrying_cube');
			getCube.removeTag(entity.name);			
			world.events.tick.unsubscribe(ticks);
			}
			});
			eventData.cancel = true;
}	
}
  
  
function entityCreated(entityData)
{
	try{
	let entityLocation = entityData.entity.location;
	let getX = Math.floor(entityLocation.x);
	let getY = Math.floor(entityLocation.y);
	let getZ = Math.floor(entityLocation.z);
	
	let dimension = entityData.entity.dimension;	
	let entityQ = new EntityQueryOptions();
	entityQ.location = entityLocation;
	entityQ.closest = 3;
	entityQ.maxDistance = 3;
	let getEntities = Array.from(dimension.getEntities(entityQ));
	
	//portal bullet
	Portalgun.getBullet(entityData,getEntities,dimension);	
	
	//portal creation
	let portalId = entityData.entity.id;
	if(portalId == "pg:portal_b_glados" || portalId == "pg:portal_o_glados" || portalId == "pg:portal_b" || portalId == "pg:portal_o" || portalId == "pg:portal_rnm1" || portalId == "pg:portal_rnm2" || portalId == "pg:block" || portalId == "pg:block2" || portalId == "pg:blackhole_entity" || portalId == "pg:blackhole_entity2"){		
	if(getEntities.length>0){
		let pBullet = getEntities.find(bullet => bullet.id == "pg:bullet_b_glados" || bullet.id == "pg:bullet_o_glados" || bullet.id == "pg:bullet_b" || bullet.id == "pg:bullet_o" || bullet.id == "pg:bullet_rnm1" || bullet.id == "pg:bullet_rnm2" || bullet.id == "pg:bullet_levitate_glados" || bullet.id == "pg:bullet_levitate" || bullet.id == "pg:blackhole_bullet" || bullet.id == "pg:blackhole_bullet2");
		if(!pBullet) return;
		Portalgun.despawn(pBullet.nameTag,dimension);				
		entityData.entity.nameTag = pBullet.nameTag;					
	}		
	}
	}catch(e){
	//world.getDimension(`overworld`).runCommand(`say ${e}`);	
	}
	
}

function onTick()
{
let getAllPlayers = Array.from(world.getPlayers());
for(let player of getAllPlayers){
	player_barrier(player);
	let entityQ = new EntityQueryOptions();
	entityQ.name = player.name;
	entityQ.families = ['block'];
	entityQ.excludeTags = ['shoot'];
	let dimension = player.dimension;
	let blockEntity = Array.from(dimension.getEntities(entityQ));
	entityQ = new EntityQueryOptions();
	entityQ.name = player.name;
	entityQ.families = ['block'];
	entityQ.tags = ['shoot'];
	let blockEntityShoot = Array.from(dimension.getEntities(entityQ));
	//despawnManager(dimension);
	portalManager(dimension,player);
	if(!blockEntity.length && !blockEntityShoot.length) continue;
		if(blockEntity.length){
			levitateBlockManager(dimension,player);
	}else if(blockEntityShoot.length){
		placeBlockManager(dimension,player,blockEntityShoot);
	}
}
}

//For portal barrier block
function player_barrier(player){
try{
player.runCommand("fill ~-1 ~-2 ~1 ~1 ~2 ~-1 pg:barrier_block_active -1 replace pg:barrier_block_inactive -1");	
}catch(e){}
try{
player.runCommand("fill ~-1 ~-2 ~1 ~1 ~2 ~-1 pg:barrier_block_active_side -1 replace pg:barrier_block_inactive_side -1");	
}catch(e){}
}

function placeBlockManager(dimension,player,blockEntityShoot){
try{
	//check sides for air blocks
	dimension.runCommand(`execute @e[name="${player.name}",family=block,tag=shoot] ~ ~ ~ testforblock ~ ~-0.9 ~ air`);
	dimension.runCommand(`execute @e[name="${player.name}",family=block,tag=shoot] ~ ~ ~ testforblock ~ ~1 ~ air`);
	dimension.runCommand(`execute @e[name="${player.name}",family=block,tag=shoot] ~ ~ ~ testforblock ~1 ~ ~ air`);
	dimension.runCommand(`execute @e[name="${player.name}",family=block,tag=shoot] ~ ~ ~ testforblock ~-1 ~ ~ air`);
	dimension.runCommand(`execute @e[name="${player.name}",family=block,tag=shoot] ~ ~ ~ testforblock ~ ~ ~1 air`);
	dimension.runCommand(`execute @e[name="${player.name}",family=block,tag=shoot] ~ ~ ~ testforblock ~ ~ ~-1 air`);
}catch(e){	
	let bTag = blockEntityShoot[0].getTags().find(tag=>tag.includes('block:'));
	bTag = bTag.split(';');
	let loc = blockEntityShoot[0].location;
	let x = Math.floor(loc.x);
	let y = Math.floor(loc.y+0.2);
	let z = Math.floor(loc.z);	

	let newPermu = MinecraftBlockTypes.get(`${bTag[0].split(':')[1]}:${bTag[0].split(':')[2]}`).createDefaultBlockPermutation();
		bTag.shift();
		bTag = bTag.filter(c=>!c.includes('valid'));
		bTag = (bTag.toString().split(':')).toString().split(',').filter(c=>!c.includes('value')).filter(c=>!c.includes('name'));
		//dimension.runCommand(`say ${bTag.length}`);	
		if(bTag.length>1){										
			for(let index = 0; index<bTag.length; index++){	
				//if(bTag[index].includes('type')){
				let prop = (bTag[index]);
				let value = (bTag[index+1]);
				//dimension.runCommand(`say ${prop}-${checkValue(value)}`);
				newPermu.getProperty(prop).value = checkValue(value);
				index+=1;
						//}
			}
		}
		dimension.runCommand(`setblock ${x} ${y} ${z} air 0 destroy`);
		//if(!blockEntity[0].dimension.getBlock(new BlockLocation(x,y,z)).type.id.includes('air')) continue;
		blockEntityShoot[0].dimension.getBlock(new BlockLocation(x,y,z)).setPermutation(newPermu);
		blockEntityShoot[0].triggerEvent('despawn');	
	
}
}

function levitateBlockManager(dimension,player){
let item = player.getComponent('inventory').container.getItem(player.selectedSlot);
if(!item) return;
	if(item.id == 'pg:portal_gun_levitation_beta' || item.id == 'pg:portal_gun_levitation2_beta'){
	try{
	dimension.runCommand(`execute @a[name="${player.name}"] ~ ~ ~ tp @e[name="${player.name}",family=block,tag=!shoot] ^ ^1.5 ^1`);
	}catch(e){}
	}	
}

function portalManager(dimension,player){
//Teleport players to portals
	try{
	let playerVelo = player.velocity;
	var pNext;
	var tag;	
	var arrPortal = (dimension.runCommand(`testfor @e[family=portal]`)).victim;	
		if(arrPortal.length>0){
		for(var c in arrPortal){
			try{
				if(arrPortal[c].includes("Portal1")){
				pNext = (arrPortal[c].slice(0, arrPortal[c].length - 1)) + "2";	
				tag = "pgteleport1";				
				if(dimension.runCommand(`testfor @e[tag=${tag}]`)){
				dimension.runCommand(`gamerule sendcommandfeedback false`);	
				dimension.runCommand(`execute @e[name="${arrPortal[c]}"] ~ ~ ~ tp @e[r=0.5,tag=${tag}] @e[name="${pNext}"]`);	
				dimension.runCommand(`execute @e[tag=${tag}] ~ ~ ~ tp @s ~ ~ ~ facing ^ ^ ^1`);	
				dimension.runCommand(`execute @e[tag=${tag}] ~ ~ ~ tp ~ ~ ~ ~ 0`);	
				dimension.runCommand(`execute @e[tag=${tag}] ~ ~ ~ tp ^ ^ ^1`);
				dimension.runCommand(`tag @e[tag=${tag}] remove ${tag}`);
				dimension.runCommand(`gamerule sendcommandfeedback true`);
				player.setVelocity(playerVelo);
				}
				}else{
				pNext = (arrPortal[c].slice(0, arrPortal[c].length - 1)) + "1";
				tag = "pgteleport2";
				if(dimension.runCommand(`testfor @e[tag=${tag}]`)){
				dimension.runCommand(`gamerule sendcommandfeedback false`);	
				dimension.runCommand(`execute @e[name="${arrPortal[c]}"] ~ ~ ~ tp @e[r=0.5,tag=${tag}] @e[name="${pNext}"]`);	
				dimension.runCommand(`execute @e[tag=${tag}] ~ ~ ~ tp @s ~ ~ ~ facing ^ ^ ^1`);	
				dimension.runCommand(`execute @e[tag=${tag}] ~ ~ ~ tp ~ ~ ~ ~ 0`);	
				dimension.runCommand(`execute @e[tag=${tag}] ~ ~ ~ tp ^ ^ ^1`);
				dimension.runCommand(`tag @e[tag=${tag}] remove ${tag}`);
				dimension.runCommand(`gamerule sendcommandfeedback true`);
				player.setVelocity(playerVelo);
				}	
				}
			}catch(e){
			//world.getDimension(`overworld`).runCommand(`say ${e}`);		
			}
			}				
		}
	}catch(e){
	//world.getDimension(`overworld`).runCommand(`say ${e}`);	
	}	
}

function despawnManager(dimension){
//despawn entity when tagged	
	try{	
	dimension.runCommand(`execute @e[tag=pgdespawn] ~ ~ ~ event entity @s despawn`);
	}catch(e){}	
//despawn blackhole entity when tagged	
	try{	
	var arrBhole = (dimension.runCommand(`testfor @e[family=bb]`)).victim;
		for(var c in arrBhole){
			try{
			dimension.runCommand(`event entity @e[name="${arrBhole[c]}",family=blackhole] despawn`)	
			}catch(e){}
		}
	}catch(e){}		
}

function blockToItem(block){
try{
let blockId = block.id;
//world.getDimension(`overworld`).runCommand(`say ${block.id}`);
	//Change concrete powder to match item id
	if(blockId.includes(`powder`)) blockId = 'minecraft:concrete_powder';
	//Change slabs to match item id
	if(blockId.includes(`stone_slab`) && !blockId.includes(`double_`)){
		blockId = blockId.split(':')[0] + ':' + 'double_' + blockId.split(':')[1];	
	}
	//Change sign to match item id
	if(blockId.includes(`_standing`)) blockId = blockId.replace(/_standing/g,'');
	if(blockId==`minecraft:standing_sign`) blockId = "minecraft:oak_sign";
	if(blockId.includes('dark') && blockId.includes('sign')) blockId = "minecraft:dark_oak_sign";
	
let currentValue = '';
let validValues = [];
let blockData;
	for(let p of block.permutation.getAllProperties()){
		for(let p2 in p){
			if(p[p2].includes('type') || p[p2].includes('color')){	
			let bProperty = block.permutation.getProperty(p[p2]);
			currentValue = bProperty.value;
			validValues = bProperty.validValues;
			blockData = validValues.findIndex(value=>value==currentValue);	
			let newItemStack = new ItemStack(Items.get(blockId),1,blockData);
			//world.getDimension(`overworld`).runCommand(`say ${newItemStack.id}`);	
			return newItemStack;			
			}else{
			return new ItemStack(Items.get(blockId),1,0);	
			}
		}
	}
	return new ItemStack(Items.get(blockId),1,0);
}catch(e){
//world.getDimension(`overworld`).runCommand(`say ${e}`);	
}
}

function checkValue(value){
	if(value == 'true'){
		return true;
	}else if(value == 'false'){
		return false;
	}
	if(parseInt(value)){		
		return parseInt(value);
	}else{
		if(parseInt(value)>=0){
			return parseInt(value);
		}
	}
	return value;
}