import { MinecraftItemTypes,Items,ItemStack, BlockPermutation, MinecraftBlockTypes,EntityRaycastOptions, Location, Vector, BlockRaycastOptions, BlockLocation, world, EntityQueryOptions} from 'mojang-minecraft';
import * as Minecraft from 'mojang-minecraft';
import { Portalgun } from "scripts/Portalgun.js";
    
const tickCallback = Minecraft.world.events.tick;
const entityCallback = Minecraft.world.events.entityCreate;

tickCallback.subscribe(onTick);
entityCallback.subscribe(entityCreated);	

const forbiddenBlocks = ['barrier','bedrock'];
  
world.events.beforeChat.subscribe((eventData) => {
if(eventData.message != '!pg test') return;
eventData.sender.runCommand(`say ${eventData.sender.getComponent('inventory').container.getItem(eventData.sender.selectedSlot).id}`);
//eventData.sender.runCommand(`execute @s ~ ~ ~ loot spawn ~ ~ ~ loot "entities/chicken"`);
eventData.cancel = true;
});	
  
world.events.beforeItemUse.subscribe((eventData) => {
try{
let item = eventData.item;
let entity = eventData.source;
if(entity.id != 'minecraft:player') return;
let loc = entity.location;
let x = loc.x;
let y = loc.y;
let z = loc.z;
let dimension = entity.dimension;
let bRayCast = new BlockRaycastOptions();
let eQuery = new EntityQueryOptions();
eQuery.closest = 1;
eQuery.location = loc;
eQuery.families = ['block'];
eQuery.name = entity.name;
let entityBlocks = Array.from(dimension.getEntities(eQuery));
bRayCast.includeLiquidBlocks = false;
bRayCast.includePassableBlocks = true;
bRayCast.maxDistance = 5;
let block = entity.getBlockFromViewVector(bRayCast);
	if(item.id == 'pg:portal_gun_levitation_beta' || item.id == 'pg:portal_gun_levitation2_beta'){
		let getCooldown = item.getComponent('minecraft:cooldown').cooldownTicks;
		//suppose to stop when in cooldown but it doesn't apparently
		if(getCooldown==20){
		if(entity.viewVector.y < -0.97) return;
		try{
		let eRayCast = new EntityRaycastOptions();
		eRayCast.maxDistance = 5;
		let entityShoot = entity.getEntitiesFromViewVector(eRayCast);
			if(((block && !entityBlocks.length) && !forbiddenBlocks.find(name=>block.id.includes(name))) && !entityShoot.length){
				let blockItem = blockToItem(block);
				let blockEntity = dimension.spawnEntity('pg:block',new Location(block.location.x,block.location.y,block.location.z));
				blockEntity.nameTag = entity.name;
					//Places converted block into main hand
					if(blockItem){
						try{
						let blockitemId = blockItem.id;
						if(blockItem.id.includes('minecraft:')){
							blockitemId = blockItem.id.split(':')[1];	
						//I hate you concrete powder and stone slabs
						if(blockitemId.includes('powder')) blockitemId = blockitemId.replace(/_/g,'');		
						if(blockitemId.includes('double_')) blockitemId = blockitemId.replace(/double_/g,'');	
						}
							//blockEntity.runCommand(`say ${blockitemId}`);		
							blockEntity.runCommand(`replaceitem entity @s slot.weapon.mainhand 0 ${blockitemId} 1 ${blockItem.data}`);
						}catch(e){}
					}
				let newTag = `block:${block.type.id}`
				for(let p of block.permutation.getAllProperties()){
					for(let p2 in p){
						newTag = newTag+`;${p2}:${p[p2]}`;
						//dimension.runCommand(`say ${p2} - ${p[p2]}`);	
					}
				}
				blockEntity.addTag(newTag);
				//dimension.runCommand(`setblock ${block.location.x} ${block.location.y} ${block.location.z} air 0 destroy`);
				block.setType(MinecraftBlockTypes.get('minecraft:air'));
			}else if(entityBlocks.length && entityBlocks[0].runCommand(`testforblock ~ ~ ~ air`)){				
				entityBlocks[0].addTag('shoot');
				if(entity.isSneaking) return;
				entityBlocks[0].setVelocity(new Vector(entity.viewVector.x*3,entity.viewVector.y*1.5,entity.viewVector.z*3));	
			}else if(entityShoot.length){
				if(entityShoot[0].id.split(':')[0] == 'pg') return;
				entityShoot[0].setVelocity(new Vector(entity.viewVector.x*3,entity.viewVector.y+0.3*2,entity.viewVector.z*3));
			}
		}catch(e){
		//world.getDimension(`overworld`).runCommand(`say ${e}`);		
		}
		
		}
	}
}catch(e){
//world.getDimension(`overworld`).runCommand(`say ${e}`);	
}
});  
  
  
function entityCreated(entityData)
{
	let entityLocation = entityData.entity.location;
	let getX = Math.floor(entityLocation.x);
	let getY = Math.floor(entityLocation.y);
	let getZ = Math.floor(entityLocation.z);
	
	let dimension = entityData.entity.dimension;	
	let getEntities = dimension.getEntitiesAtBlockLocation(new BlockLocation(getX,getY,getZ));
	
	//portal bullet
	Portalgun.getBullet(entityData,getEntities,dimension);	
	//portal creation
	let portalId = entityData.entity.id;
	if(portalId == "pg:portal_b_glados" || portalId == "pg:portal_o_glados" || portalId == "pg:portal_b" || portalId == "pg:portal_o" || portalId == "pg:portal_rnm1" || portalId == "pg:portal_rnm2" || portalId == "pg:block" || portalId == "pg:block2" || portalId == "pg:blackhole_entity" || portalId == "pg:blackhole_entity2"){		
	if(getEntities.length>0){
		let pBullet = getEntities.find(bullet => bullet.id == "pg:bullet_b_glados" || bullet.id == "pg:bullet_o_glados" || bullet.id == "pg:bullet_b" || bullet.id == "pg:bullet_o" || bullet.id == "pg:bullet_rnm1" || bullet.id == "pg:bullet_rnm2" || bullet.id == "pg:bullet_levitate_glados" || bullet.id == "pg:bullet_levitate" || bullet.id == "pg:blackhole_bullet" || bullet.id == "pg:blackhole_bullet2");
		if(!pBullet) return;
		Portalgun.despawn(pBullet.nameTag,dimension);				
		entityData.entity.nameTag = pBullet.nameTag;					
	}		
	}
	
}

function onTick()
{
//It's very messy and inefficient but hey it works. (Will (not) change it when new 1.18 api comes out)
	let dimension = world.getDimension("overworld");
	let entities;
	const entityQ = new EntityQueryOptions;
	entityQ.families = ['pg','block'];
	
	for(var dm=0; dm<3; dm++){
	if(dm==1){
	dimension = world.getDimension("nether");	
		entities = (Array.from(dimension.getEntities(entityQ))).length;
		if(entities<=0) continue;
	}
	if(dm==2){
	dimension = world.getDimension("the end");	
		entities = (Array.from(dimension.getEntities(entityQ))).length;
		if(entities<=0) continue;
	}
//despawn entity when tagged	
	try{	
	dimension.runCommand(`execute @e[tag=pgdespawn] ~ ~ ~ event entity @s despawn`);
	}catch(e){}	
//despawn blackhole entity when tagged	
	try{	
	var arrBhole = (dimension.runCommand(`testfor @e[family=bb]`)).victim;
		for(var c in arrBhole){
			try{
			dimension.runCommand(`event entity @e[name="${arrBhole[c]}",family=blackhole] despawn`)	
			}catch(e){}
		}
	}catch(e){}	

//Teleport players to portals
	try{
	var pNext;
	var tag;	
	var arrPortal = (dimension.runCommand(`testfor @e[family=portal]`)).victim;	
		if(arrPortal.length>0){
		for(var c in arrPortal){
			try{
				if(arrPortal[c].includes("Portal1")){
				pNext = (arrPortal[c].slice(0, arrPortal[c].length - 1)) + "2";	
				tag = "pgteleport1";				
				if(dimension.runCommand(`testfor @e[tag=${tag}]`)){
				dimension.runCommand(`gamerule sendcommandfeedback false`);	
				dimension.runCommand(`execute @e[name="${arrPortal[c]}"] ~ ~ ~ tp @e[r=0.5,tag=${tag}] @e[name="${pNext}"]`);	
				dimension.runCommand(`execute @e[tag=${tag}] ~ ~ ~ tp @s ~ ~ ~ facing ^ ^ ^1`);	
				dimension.runCommand(`execute @e[tag=${tag}] ~ ~ ~ tp ~ ~ ~ ~ 0`);	
				dimension.runCommand(`execute @e[tag=${tag}] ~ ~ ~ tp ^ ^ ^1`);
				dimension.runCommand(`tag @e[tag=${tag}] remove ${tag}`);
				dimension.runCommand(`gamerule sendcommandfeedback true`);
				}
				}else{
				pNext = (arrPortal[c].slice(0, arrPortal[c].length - 1)) + "1";
				tag = "pgteleport2";
				if(dimension.runCommand(`testfor @e[tag=${tag}]`)){
				dimension.runCommand(`gamerule sendcommandfeedback false`);	
				dimension.runCommand(`execute @e[name="${arrPortal[c]}"] ~ ~ ~ tp @e[r=0.5,tag=${tag}] @e[name="${pNext}"]`);	
				dimension.runCommand(`execute @e[tag=${tag}] ~ ~ ~ tp @s ~ ~ ~ facing ^ ^ ^1`);	
				dimension.runCommand(`execute @e[tag=${tag}] ~ ~ ~ tp ~ ~ ~ ~ 0`);	
				dimension.runCommand(`execute @e[tag=${tag}] ~ ~ ~ tp ^ ^ ^1`);
				dimension.runCommand(`tag @e[tag=${tag}] remove ${tag}`);
				dimension.runCommand(`gamerule sendcommandfeedback true`);
				}	
				}				
			}catch(e){}
			}				
		}
	}catch(e){}

//Levitates Block
	try{
	let arrBlock = '';
	let getOwnerPlayer = [];
	const blockQ = new EntityQueryOptions;
	blockQ.families = ['block'];
	blockQ.excludeTags = ['shoot'];
	let blockArray = Array.from(dimension.getEntities(blockQ));
	const playerQ = new EntityQueryOptions;
		if(blockArray.length>0){
		for(let c = 0; c<blockArray.length; c++){
			arrBlock = blockArray[c].nameTag;
			if(arrBlock.includes('pg:block')) {
				//dimension.runCommand(`event entity @e[name="",type=pg:block] despawn`);
				//dimension.runCommand(`event entity @e[name="",type=pg:block2] despawn`);
				continue;
			}
			playerQ.name = arrBlock;
			getOwnerPlayer = Array.from(world.getPlayers(playerQ));
				if(getOwnerPlayer.length <= 0) {
				//dimension.runCommand(`event entity @e[name="${arrBlock}",type=pg:block] despawn`);
				//dimension.runCommand(`event entity @e[name="${arrBlock}",type=pg:block2] despawn`);
				continue;	
				}
			let itemSelected = getOwnerPlayer[0].selectedSlot;	
			let getItem = getOwnerPlayer[0].getComponent('inventory').container.getItem(itemSelected);
			if(!getItem){
				try{
				//dimension.runCommand(`tag @e[name="${arrBlock}",family=block,tag=!shoot] add shoot`);
				continue;
				}catch(e){}	
			}
			let itemId = getItem.id;
			if(itemId == 'pg:portal_gun_levitation_beta' || itemId == 'pg:portal_gun_levitation2_beta'){
				try{
				dimension.runCommand(`execute @e[name="${arrBlock}",family=player] ~ ~ ~ tp @e[name="${arrBlock}",family=block,tag=!shoot] ^ ^1.5 ^1`);
				}catch(e){}
			}else{
				try{
				//dimension.runCommand(`tag @e[name="${arrBlock}",family=block,tag=!shoot] add shoot`);
				}catch(e){}				
			}
			}				
		}
	}catch(e){
	//dimension.runCommand(`say ${e}`)
	}
//Makes entity block into a solid block	
	try{
	var arrBlock = (dimension.runCommand(`testfor @e[family=block,tag=shoot]`)).victim;
		if(arrBlock.length>0){
		for(var c in arrBlock){
			let entityQ = new EntityQueryOptions();
			entityQ.name = arrBlock[c];
			let getPlayer = Array.from(world.getPlayers(entityQ));
			if(!getPlayer[0].getComponent('inventory').container.getItem(getPlayer[0].selectedSlot)) continue;
			let itemId = getPlayer[0].getComponent('inventory').container.getItem(getPlayer[0].selectedSlot).id;
			try{
			if(itemId == 'pg:portal_gun_levitation_beta' || itemId == 'pg:portal_gun_levitation2_beta'){
			//check sides for air blocks
			dimension.runCommand(`execute @e[name="${arrBlock[c]}",family=block,tag=shoot] ~ ~ ~ testforblock ~ ~-0.9 ~ air`);
			dimension.runCommand(`execute @e[name="${arrBlock[c]}",family=block,tag=shoot] ~ ~ ~ testforblock ~ ~1 ~ air`);
			dimension.runCommand(`execute @e[name="${arrBlock[c]}",family=block,tag=shoot] ~ ~ ~ testforblock ~1 ~ ~ air`);
			dimension.runCommand(`execute @e[name="${arrBlock[c]}",family=block,tag=shoot] ~ ~ ~ testforblock ~-1 ~ ~ air`);
			dimension.runCommand(`execute @e[name="${arrBlock[c]}",family=block,tag=shoot] ~ ~ ~ testforblock ~ ~ ~1 air`);
			dimension.runCommand(`execute @e[name="${arrBlock[c]}",family=block,tag=shoot] ~ ~ ~ testforblock ~ ~ ~-1 air`);
			}
			}catch(e){
			//if detects non air block turns into solid block
				try{				
				let eQuery = new EntityQueryOptions();
				eQuery.name = arrBlock[c];
				eQuery.families = ['block'];
				let blockEntity = Array.from(dimension.getEntities(eQuery));
				let bTag = blockEntity[0].getTags().find(tag=>tag.includes('block:'));
				bTag = bTag.split(';');
				let loc = blockEntity[0].location;
				let x = Math.floor(loc.x);
				let y = Math.floor(loc.y+0.2);
				let z = Math.floor(loc.z);				
				
				let newPermu = MinecraftBlockTypes.get(`${bTag[0].split(':')[1]}:${bTag[0].split(':')[2]}`).createDefaultBlockPermutation();
				bTag.shift();
				bTag = bTag.filter(c=>!c.includes('valid'));
				bTag = (bTag.toString().split(':')).toString().split(',').filter(c=>!c.includes('value')).filter(c=>!c.includes('name'));
				//dimension.runCommand(`say ${bTag.length}`);	
				if(bTag.length>1){										
					for(let index = 0; index<bTag.length; index++){	
						//if(bTag[index].includes('type')){
						let prop = (bTag[index]);
						let value = (bTag[index+1]);
						//dimension.runCommand(`say ${prop}-${checkValue(value)}`);
						newPermu.getProperty(prop).value = checkValue(value);
						index+=1;
						//}
					}
				}
				dimension.runCommand(`setblock ${x} ${y} ${z} air 0 destroy`);
				//if(!blockEntity[0].dimension.getBlock(new BlockLocation(x,y,z)).type.id.includes('air')) continue;
				blockEntity[0].dimension.getBlock(new BlockLocation(x,y,z)).setPermutation(newPermu);
				blockEntity[0].triggerEvent('despawn');	
		
				}catch(e){
				//dimension.runCommand(`say ${e}`);
				}

			}
			}				
		}			
	}catch(e){
	//dimension.runCommand(`say ${e}`);	
	}
	}
}

function blockToItem(block){
try{
let blockId = block.id;
//world.getDimension(`overworld`).runCommand(`say ${block.id}`);
	//Change concrete powder to match item id
	if(blockId.includes(`powder`)) blockId = 'minecraft:concrete_powder';
	//Change slabs to match item id
	if(blockId.includes(`stone_slab`) && !blockId.includes(`double_`)){
		blockId = blockId.split(':')[0] + ':' + 'double_' + blockId.split(':')[1];	
	}
	//Change sign to match item id
	if(blockId.includes(`_standing`)) blockId = blockId.replace(/_standing/g,'');
	if(blockId==`minecraft:standing_sign`) blockId = "minecraft:oak_sign";
	if(blockId.includes('dark') && blockId.includes('sign')) blockId = "minecraft:dark_oak_sign";
	
let currentValue = '';
let validValues = [];
let blockData;
	for(let p of block.permutation.getAllProperties()){
		for(let p2 in p){
			if(p[p2].includes('type') || p[p2].includes('color')){	
			let bProperty = block.permutation.getProperty(p[p2]);
			currentValue = bProperty.value;
			validValues = bProperty.validValues;
			blockData = validValues.findIndex(value=>value==currentValue);	
			let newItemStack = new ItemStack(Items.get(blockId),1,blockData);
			return newItemStack;			
			}else{
			return new ItemStack(Items.get(blockId),1,0);	
			}
		}
	}
	return new ItemStack(Items.get(blockId),1,0);
}catch(e){
//world.getDimension(`overworld`).runCommand(`say ${e}`);	
}
}

function checkValue(value){
	if(value == 'true'){
		return true;
	}else if(value == 'false'){
		return false;
	}
	if(parseInt(value)){		
		return parseInt(value);
	}else{
		if(parseInt(value)>=0){
			return parseInt(value);
		}
	}
	return value;
}