import { BlockLocation, world, EntityQueryOptions} from 'mojang-minecraft';
import * as Minecraft from 'mojang-minecraft';
import { Portalgun } from "scripts/Portalgun.js";
    
const tickCallback = Minecraft.world.events.tick;
const entityCallback = Minecraft.world.events.entityCreate;

tickCallback.subscribe(onTick);
entityCallback.subscribe(entityCreated);	
  
function entityCreated(entityData)
{
	let entityLocation = entityData.entity.location;
	let getX = Math.floor(entityLocation.x);
	let getY = Math.floor(entityLocation.y);
	let getZ = Math.floor(entityLocation.z);
	
	let dimension = entityData.entity.dimension;	
	let getEntities = dimension.getEntitiesAtBlockLocation(new BlockLocation(getX,getY,getZ));
	
	//portal bullet
	Portalgun.getBullet(entityData,getEntities,dimension);	
	//portal creation
	let portalId = entityData.entity.id;
	if(portalId == "pg:portal_b_glados" || portalId == "pg:portal_o_glados" || portalId == "pg:portal_b" || portalId == "pg:portal_o" || portalId == "pg:portal_rnm1" || portalId == "pg:portal_rnm2" || portalId == "pg:block" || portalId == "pg:block2" || portalId == "pg:blackhole_entity" || portalId == "pg:blackhole_entity2"){		
	if(getEntities.length>0){
		let pBullet = getEntities.find(bullet => bullet.id == "pg:bullet_b_glados" || bullet.id == "pg:bullet_o_glados" || bullet.id == "pg:bullet_b" || bullet.id == "pg:bullet_o" || bullet.id == "pg:bullet_rnm1" || bullet.id == "pg:bullet_rnm2" || bullet.id == "pg:bullet_levitate_glados" || bullet.id == "pg:bullet_levitate" || bullet.id == "pg:blackhole_bullet" || bullet.id == "pg:blackhole_bullet2");
		if(!pBullet) return;
		Portalgun.despawn(pBullet.nameTag,dimension);				
		entityData.entity.nameTag = pBullet.nameTag;					
	}		
	}
	
}

function onTick()
{
//It's very messy and inefficient but hey it works. (Will change it when new 1.18 api comes out)
	let dimension = world.getDimension("overworld");
	let entities;
	
	const entityQ = new EntityQueryOptions;
	entityQ.families = ['pg','block'];
	
	for(var dm=0; dm<3; dm++){
	if(dm==1){
	dimension = world.getDimension("nether");	
		entities = (Array.from(dimension.getEntities(entityQ))).length;
		if(entities<=0) continue;
	}
	if(dm==2){
	dimension = world.getDimension("the end");
		entities = (Array.from(dimension.getEntities(entityQ))).length;
		if(entities<=0) continue;
	}
//despawn entity when tagged	
	try{	
	dimension.runCommand(`execute @e[tag=pgdespawn] ~ ~ ~ event entity @s despawn`);
	dimension.runCommand(`execute @e[tag=pgdespawn] ~ ~ ~ event entity @s despawn`);
	dimension.runCommand(`execute @e[tag=pgdespawn] ~ ~ ~ event entity @s despawn`);
	}catch(e){}	
//despawn blackhole entity when tagged	
	try{	
	var arrBhole = (dimension.runCommand(`testfor @e[family=bb]`)).victim;
		for(var c in arrBhole){
			try{
			dimension.runCommand(`event entity @e[name="${arrBhole[c]}",family=blackhole] despawn`)	
			}catch(e){}
		}
	}catch(e){}	

//Teleport players to portals
	try{
	//Commands.run(`say test4`,dimension);
	var pNext;
	var tag;	
	var arrPortal = (dimension.runCommand(`testfor @e[family=portal]`)).victim;	
		if(arrPortal.length>0){
		for(var c in arrPortal){
			try{
				if(arrPortal[c].includes("Portal1")){
				pNext = (arrPortal[c].slice(0, arrPortal[c].length - 1)) + "2";	
				tag = "pgteleport1";				
				if(dimension.runCommand(`testfor @e[tag=${tag}]`)){
				dimension.runCommand(`gamerule sendcommandfeedback false`);	
				dimension.runCommand(`execute @e[name="${arrPortal[c]}"] ~ ~ ~ tp @e[r=0.5,tag=${tag}] @e[name="${pNext}"]`);	
				dimension.runCommand(`execute @e[tag=${tag}] ~ ~ ~ tp @s ~ ~ ~ facing ^ ^ ^1`);	
				dimension.runCommand(`execute @e[tag=${tag}] ~ ~ ~ tp ~ ~ ~ ~ 0`);	
				dimension.runCommand(`execute @e[tag=${tag}] ~ ~ ~ tp ^ ^ ^1`);
				dimension.runCommand(`tag @e[tag=${tag}] remove ${tag}`);
				dimension.runCommand(`gamerule sendcommandfeedback true`);
				}
				}else{
				pNext = (arrPortal[c].slice(0, arrPortal[c].length - 1)) + "1";	;
				tag = "pgteleport2";
				if(dimension.runCommand(`testfor @e[tag=${tag}]`)){
				dimension.runCommand(`gamerule sendcommandfeedback false`);	
				dimension.runCommand(`execute @e[name="${arrPortal[c]}"] ~ ~ ~ tp @e[r=0.5,tag=${tag}] @e[name="${pNext}"]`);	
				dimension.runCommand(`execute @e[tag=${tag}] ~ ~ ~ tp @s ~ ~ ~ facing ^ ^ ^1`);	
				dimension.runCommand(`execute @e[tag=${tag}] ~ ~ ~ tp ~ ~ ~ ~ 0`);	
				dimension.runCommand(`execute @e[tag=${tag}] ~ ~ ~ tp ^ ^ ^1`);
				dimension.runCommand(`tag @e[tag=${tag}] remove ${tag}`);
				dimension.runCommand(`gamerule sendcommandfeedback true`);
				}	
				}				
			}catch(e){}
			}				
		}
	}catch(e){}
	
//Levitates Block
	try{
	var arrBlock = (dimension.runCommand(`testfor @e[family=block,tag=!shoot]`)).victim;	
		if(arrBlock.length>0){
		for(var c in arrBlock){
			try{
			dimension.runCommand(`execute @e[name="${arrBlock[c]}",family=player] ~ ~ ~ tp @e[name="${arrBlock[c]}",family=block,tag=!shoot] ^ ^1 ^1`);
			}catch(e){}
			}				
		}
	}catch(e){}
//Makes entity block into a solid block	
	try{
	var arrBlock = (dimension.runCommand(`testfor @e[family=block,tag=shoot]`)).victim;
		if(arrBlock.length>0){
		for(var c in arrBlock){
			try{
			//check sides for air blocks
			dimension.runCommand(`execute @e[name="${arrBlock[c]}",family=block,tag=shoot] ~ ~ ~ testforblock ~ ~-0.2 ~ air`);
			dimension.runCommand(`execute @e[name="${arrBlock[c]}",family=block,tag=shoot] ~ ~ ~ testforblock ~ ~0.2 ~ air`);
			dimension.runCommand(`execute @e[name="${arrBlock[c]}",family=block,tag=shoot] ~ ~ ~ testforblock ~0.2 ~ ~ air`);
			dimension.runCommand(`execute @e[name="${arrBlock[c]}",family=block,tag=shoot] ~ ~ ~ testforblock ~-0.2 ~ ~ air`);
			dimension.runCommand(`execute @e[name="${arrBlock[c]}",family=block,tag=shoot] ~ ~ ~ testforblock ~ ~ ~0.2 air`);
			dimension.runCommand(`execute @e[name="${arrBlock[c]}",family=block,tag=shoot] ~ ~ ~ testforblock ~ ~ ~-0.2 air`);
			}catch(e){
			//if detects non air block turns into solid block
			dimension.runCommand(`execute @e[name="${arrBlock[c]}",family=block,tag=shoot] ~ ~ ~ function setBlock`);	
			}
			}				
		}			
	}catch(e){}
	}
}